           output file=results.out reset;
           cls;

           @ The following lines read in the raw data, and convert to
             100 times the first difference of the log @
        
           offset=0;
           start=1+offset;
           strend=0;
           sbreak=0;
           obs = 149;
           load bbbb[obs+1,1] = us_sales_sa.txt; adjust=0; jointest=0;

           bbbb = bbbb[start:obs,1]~bbbb[start+1:obs+1,1];
           y = 100*ln(bbbb[.,2]./bbbb[.,1]);
           obs=obs-start+1;
           capt=rows(y);

@ 123 is 1997.50 sales no trend@
@ 102 is 1992.25 sales trend@
@  95 is 1990.50 wsales no trend@
@  23 is 1972.50 wsales trend@
@  31 is 1974.50 jsales no trend@
@  73 is 1984.75 jsales trend@
@ 115 is 1995.75 jsales no trend@

sbrkdate = 115+offset+1;
seasonbreak = zeros(sbrkdate-1,1)|ones(rows(y)-sbrkdate+1,1);  
seasont = seqa(1,1,rows(y)).*(1-seasonbreak);
season2t = seqa(1,1,rows(y)).*(seasonbreak);

dummies = 1|0|0|0; 
j = 1;
     do until j > (obs/4)+8;
        dummies = dummies|1|0|0|0;
        j = j+1;   
     endo;
@ Mean -deviation dummies @
dummies = dummies-lagn(dummies,3)~lagn(dummies,1)-lagn(dummies,3)~lagn(dummies,2)-lagn(dummies,3); 
dummies = dummies[4:rows(dummies),.]; 
dummies = dummies[1:rows(y),.]; 

dummiesx = dummies.*(seasonbreak.*.ones(1,3)); 
dummiest = dummies.*(seasont.*.ones(1,3)); 
dummies2t = dummies.*(season2t.*.ones(1,3));
dummy97=zeros(capt,1);
dummy97[120,1]=1;  //97Q1


if adjust==1; 
@ Eliminate seasonality using break trend model @
if sbreak==1;
    if strend==1;
        xx = ones(rows(y),1)~dummies~dummiesx~dummiest ; //trend
    else;
        xx = ones(rows(y),1)~dummies~dummiesx; //no trend
    endif;
else;
    if strend==1;
        xx = ones(rows(y),1)~dummies~dummiest ; //trend
    else;
        xx = ones(rows(y),1)~dummies; //no trend
    endif;
endif;
//xx = ones(rows(y),1)~dummies; //no break 
beta = invpd(xx'*xx)*(xx'*y); 
yorig = y; 
y = y-xx*beta+beta[1]; 
endif;              

          @  Adjust any of the following to control specification desired @
           ns = 2;           @ ns is the number of primitive states @
           ps = 1;           @ ps is the number of lagged states that matter
                               for y;  use ps = 0 if only the current state
                               matters @
           pphi =ps;         @ pphi is the number of lags in autoregression
                                for y; pphi should be greater than or equal
                                to ps @
           isig = 1;         @ isig = 1 for constant variances,
                               isig =ns for changing variances @
           ipm = 1;          @ ipm specifies way in which transition probs
                               are parameterized
                                  ipm = 1 implies p11 and p22 estimated
                                  ipm = 2 implies pij for i=1,..,n j=1,..,n-1
                                  ipm = 3 user input code @
          a=0;b=0;c=0;       @ These parameters control the Bayesian prior
                               as suggested in Hamilton, "A Quasi-Bayesian
                               Approach to Estimating Parameters for Mixtures
                               of Normal Distributions", Journal of Business
                               and Economic Statistics, January 1991.   if
                               no Bayesian adjustment is desired, set all
                               parameters to zero @

          /* Input initial values for parameters
          The order in which variables are represented is as follows
             first ns elements:    means for states
             next pphi elements:   autoregressive coefficients
             next isig elements:   variances for states when izz =1
                                       std. deviations for states when izz =2
             next elements:        when izz =1 these are the transition probs
                                   when izz =2 these are params v(i,j) such that
                                       p(i,j) = v(i,j)^2 / sum j v(i,j)^2
                                   elements are ordered as p11, p22 when ns =2
                                       ordered as p(1,1),p(2,1),...,p(ns,1),
                                       p(2,1),...,p(ns-1,ns) when ns > 2 */
//STARTING VALUES
         //mu1 = 0.5; mu2 = -0.5; phi1 = .3; sig = 0.1; p11 = 4; p22 = 2;
         //mu1 = 0.6; mu2 = -0.1; phi1 = 0.3; sig = 0.3; p11 = 4; p22 = 2; //empl
         mu1 = 1.25; mu2 = -0.84; phi1 = -0.25; sig = 1.5; p11 = 4.32 ; p22 = 1.68; //sales
                  nth=5+pphi+1; @ nth is the number of params to be estimated@ 
                  if pphi==0;
                        th = mu1|mu2|sig|p11|p22|0;
                  else;
                      th = mu1|mu2|zeros(pphi,1)|sig|p11|p22|0;
                      th[3,1]=phi1; //Starting value for ar1
                  endif;

                  if jointest ==1;
                     if strend==1;
                        th=th|zeros(9,1);
                        nth=nth+6;
                     else;
                        th=th|zeros(6,1);
                        nth=nth+3;
                     endif;
                  endif;


  @ In general no parts of this section should be changed @

proc startval;     @ This defines starting value for iteration to be th @
  retp(th); endp;
nk = pphi+1;       @ nk is the first observation for which the
                             likelihood will be evaluated @
izz = 1;           @ izz = 1 when params read in so as to assure inequality
                     constraints; izz = 2 for final reporting of results @
n = ns^(ps+1);     @ n is the dimension of the state vector @
kc = 1;            @ kc = 2 to echo parameter values @
ks = 1;            @ ks = 2 if smoothed probs are to be calculated @
captst = capt - nk +1; @ captst is the effective sample size @
skif = zeros(captst,n); @ skif is the matrix of filtered probs @
skis = zeros(captst,n); @ skis is the matrix of smoothed probs @
id = eye(ns);           @ used in certain calculations below @

proc pattern1; @ This proc returns a (ps+1)*ns x n matrix.  The ith
                column contains a one in row j if st = j, contains a
                one in row ns+j if st-1 = j, and so on @
     local i1,ix,iq,na;
     na = n/ns;
     ix = eye(ns).*.ones(1,na);
     i1 = 1;
     do until i1 > ps;
       na = na/ns;
       iq = ones(1,ns^i1).*.(eye(ns).*.ones(1,na));
       ix = iq|ix;
     i1 = i1+1;
     endo;
retp(ix);
endp;

hp = pattern1;
#include procs_dummy97.prc;
/* ================================================================= */

/* ======================================================================= */
proc matpm(xth);  @This proc defines the user's conventions for reading
                 elements of Markov transition probabilities from
                 parameter vector @
   local pm,ixth;
   ixth = rows(xth);
   pm = zeros(ns,ns);
     if ipm == 1;  @ for ns =2 this option has parameters as p11 and p22 @
          if izz == 1;
             pm[1,1] = xth[1,1]^2/(1 +xth[1,1]^2);
             pm[2,2] = xth[2,1]^2/(1 + xth[2,1]^2);
          else;
             pm[1,1] = xth[1,1];
             pm[2,2] = xth[2,1];
          endif;
          pm[2,1] = 1 - pm[1,1];
          pm[1,2] = 1 - pm[2,2];
     elseif ipm == 2;  @ general case has parameters pij for i = 1,...,n and
                          j = 1,...,n-1 @
        pm[1:ns-1,.] = reshape(xth[1:ixth,1],ns-1,ns);
        if izz == 1;
           pm[ns,.] = ones(1,ns);
           pm = pm^2;
           pm = pm./(sumc(pm)');
        else;
           pm[ns,.] = (1 - sumc(pm))';
        endif;
     elseif ipm == 3;  @ This section can be rewritten by user to impose zeros
                          and ones where desired @
        if izz == 1;
             pm[1,1] = xth[1,1]^2/(1 + xth[1,1]^2);
             pm[1,2] = xth[2,1]^2/(1 + xth[2,1]^2);
             pm[2,3] = xth[3,1]^2/(1 + xth[3,1]^2);
        elseif izz == 2;
             pm[1,1] = xth[1,1];
             pm[1,2] = xth[2,1];
             pm[2,3] = xth[3,1];
        endif;
        pm[3,1] = 1 - pm[1,1];
        pm[2,2] = 1 - pm[1,2];
        pm[3,3] = 1 - pm[2,3];
    endif;
retp(pm);
endp;
/* ======================================================================= */

/* ==================================================================== */
@ Set parameters to use Gauss numerical optimizer @



     library optmum;
     #include optmum.ext;
      __btol = 1.e-06; @ This controls convergence criterion for coefficients@
      __gtol = 1.e-06; @ This controls convergence criterion for gradient @
      __algr = 1;     @ This chooses BFGS optimization  @
      _opalgr = 2;    @ This chooses BFGS optimization for newer versions of
                         GAUSS @
      __miter = 150;  @ This controls the maximum number of iterations @
      __output = 1;   @ This causes extra output to be displayed @
      __covp = 0;     @ This speeds up return from OPTMUM; note that the
                        program makes a reparameterization to calculate
                        std. errors @

@ Next call  the GAUSS numerical optimizer @
        output off;
        {x,f,g,h} =optmum(&ofn,startval);
        output file=results.out on;

"";"";"MLE as parameterized for numerical optimization ";
"Coefficients:";x';
"";"Value of log likelihood:";;-f;
bic=2*f/capt+rows(th)*ln(capt)/capt;
"";"BIC:";;bic;
"";"Gradient vector:";g';
/* ======================================================================= */

/*======================================================================== */
@ In general no parts of this section need be changed @

@ Reparameterize for reporting final results @
   izz = 2;

"";"Vector is reparameterized to report final results as follows";
   "Means for each state:";x[1:ns,1]';
   if pphi > 0;
      "Autoregressive coefficients:";x[ns+1:ns+pphi,1]';
   endif;
   ncount = ns + pphi ;
   x[ncount+1:ncount+isig,1] = x[ncount+1:ncount+isig,1]^2;
   "Variances:";x[ncount+1:ncount+isig,1];
   ncount = ncount + isig;
/* ======================================================================= */

/* ======================================================================= */
proc pmth; @ This proc converts the last elements of parameter vector
                  (which relates to transition probabilities) from the
                   th[i,j]^2/{sum j th[i,j]^2} form that is used for
                   numerical estimation into the p[i,j] form that is used
                   to calculate standard errors @
local pm;
if ipm == 1;
        x[ncount+1,1] = x[ncount+1,1]^2/(1 + x[ncount+1,1]^2);
        x[ncount+2,1] = x[ncount+2,1]^2/(1 + x[ncount+2,1]^2);
elseif ipm == 2;
        pm = zeros(ns,ns);
        pm[1:ns-1,.] = reshape(x[ncount+1:nth],ns-1,ns);
        pm[ns,.] =  ones(1,ns);
        pm = pm^2;
        pm = pm./(sumc(pm)');
        x[ncount+1:nth,1] = reshape(pm[1:ns-1,.],ns*(ns-1),1);
  elseif ipm == 3;    @ User may want to alter these next lines @
        x[ncount+1:nth,1]
          = (x[ncount+1:nth,1]^2)./(1 + x[ncount+1:nth,1]^2);
 endif;
retp(x);
endp;
/* ======================================================================= */

/* ======================================================================= */
@ In general no changes are necessary from here out @

call pmth;
h = (hessp(&ofn,x));
   va = eigrs(h);
kc = 2;
ks = 2;
call ofn(x);
   if minc(eigrs(h)) <= 0;
        "Negative of Hessian is not positive definite";
        "Either you have not found local maximum, or else estimates are up "
        "against boundary condition.  In latter case, impose the restricted "
        "params rather than estimate them to calculate standard errors";
    else;
       h = invpd(h);
       std = diag(h)^.5;
       "For vector of coefficients parameterized as follows,";x';
       "the standard errors are";std';
    endif;

/*"";"-------------------------------";"";
"Probabilities for primitive states";
"filtered probabilities";format /rd 1,0;
"Obs ";;
t = 0;
do until t > ps;
  i = 1;
    do until i == ns;
       "P(st-";;t;;"=";;i;;") ";;
     i = i+1;
     endo;
  t = t+1;
endo;"";
format /rd 6,4;
*/
 skif = (skif*hp')*(eye(ps+1).*.id[.,1:ns-1]);
 skif =  seqa(nk,1,captst)~skif;//skif;
/*
"";"smoothed probabilities";
format /rd 1,0;
"Obs ";;
i = 1;
   do until i > ns;
      "P(st = ";;i;;") ";;
   i = i+1;
   endo;
format /rd 6,4;
*/
 skis = skis*hp';
 skis = seqa(nk,1,captst)~skis[.,1:ns];//skis;
 
//========================================================================*/
prec=skis[.,cols(skis)];
xy(seqa(1967.00+(start+1-offset+ps)/4.0,.25,rows(prec)),prec);

output off;

library pgraph optmum;
optset;